<html>
<head>
<title>Ogre::RTShader::Program Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::Program Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::Program" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>A class that represents a shader based program.  
 <a href="classOgre_1_1RTShader_1_1Program.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::Program:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1Program__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1Program_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1Program_inherit__map" id="Ogre_1_1RTShader_1_1Program_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="15,5,169,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1Program-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a91593fdaa3588c534a5d567fb5c4433a">getType</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of this program.  <a href="#a91593fdaa3588c534a5d567fb5c4433a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#ae0b281147a7daf59ec04e45523df75d0">resolveAutoParameterReal</a> (<a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a> autoType, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> data, size_t size=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve uniform auto constant parameter with associated real data of this program.  <a href="#ae0b281147a7daf59ec04e45523df75d0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#afa95a589bbc662fdadf93c9fa3630508">resolveAutoParameterReal</a> (<a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a> autoType, <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> type, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> data, size_t size=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve uniform auto constant parameter with associated real data of this program.  <a href="#afa95a589bbc662fdadf93c9fa3630508"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a14f456c00a198c026043492b74f5c695">resolveAutoParameterInt</a> (<a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a> autoType, size_t data, size_t size=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve uniform auto constant parameter with associated int data of this program.  <a href="#a14f456c00a198c026043492b74f5c695"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#af9ae3761783a43cdb7016b51c5a858bd">resolveAutoParameterInt</a> (<a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a> autoType, <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> type, size_t data, size_t size=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve uniform auto constant parameter with associated int data of this program.  <a href="#af9ae3761783a43cdb7016b51c5a858bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a5587bc7123d7616527a4508706d7cc89">resolveParameter</a> (<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> type, int index, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> variability, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;suggestedName, size_t size=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve uniform parameter of this program.  <a href="#a5587bc7123d7616527a4508706d7cc89"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#ac9b3ac41bdbeb34c21b9ee428b75b859">getParameterByName</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get parameter by a given name.  <a href="#ac9b3ac41bdbeb34c21b9ee428b75b859"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#af817232435e35d8e747eed629e8a7caa">getParameterByAutoType</a> (<a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a> autoType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get parameter by a given auto constant type.  <a href="#af817232435e35d8e747eed629e8a7caa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#ad6e5c14d3511acebe76cccb40d260c96">getParameterByType</a> (<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> type, int index)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get parameter by a given type and index.  <a href="#ad6e5c14d3511acebe76cccb40d260c96"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__RTShader.html#ga76848ed6c023c3fe0a5e9f25f87b78a8">UniformParameterList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a2479cc279c86c8e782b81889862f8a7b">getParameters</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the list of uniform parameters of this program.  <a href="#a2479cc279c86c8e782b81889862f8a7b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#aa3c0b7854fb8356b68ecb3b977c3f0fb">createFunction</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;desc, const <a class="el" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccf">Function::FunctionType</a> functionType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create new function in this program.  <a href="#aa3c0b7854fb8356b68ecb3b977c3f0fb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a5ca247d24785aec3cdb24c5fec312c4b">getFunctionByName</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a function by a given name.  <a href="#a5ca247d24785aec3cdb24c5fec312c4b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#acf2a3a94886adfb88b0f85212f65c873">getFunctions</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the function list of this program.  <a href="#acf2a3a94886adfb88b0f85212f65c873"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a1d51026c1bafcac0223edb1e371c5b52">setEntryPointFunction</a> (<a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the entry point function.  <a href="#a1d51026c1bafcac0223edb1e371c5b52"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a7b7f2adb8e8b565d6ca1d1893af82b76">getEntryPointFunction</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the entry point function of this program.  <a href="#a7b7f2adb8e8b565d6ca1d1893af82b76"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a9eae71bfcd0da6a9daac3ddc52d27e25">addDependency</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;libFileName)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add dependency for this program.  <a href="#a9eae71bfcd0da6a9daac3ddc52d27e25"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#af51a20c85418f770b3fdb56f82e03830">getDependencyCount</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the number of external libs this program depends on.  <a href="#af51a20c85418f770b3fdb56f82e03830"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#acdcfe31a4b135f4e86f22f7448d063c6">getDependency</a> (unsigned int index) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the library name of the given index dependency.  <a href="#acdcfe31a4b135f4e86f22f7448d063c6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a24f1c39c59041fb580260cd1a778c9eb">setSkeletalAnimationIncluded</a> (bool value)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether a vertex program includes the required instructions to perform skeletal animation.  <a href="#a24f1c39c59041fb580260cd1a778c9eb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a3eaf8ab3e4b834a0ad24d70e210263cb">getSkeletalAnimationIncluded</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether a vertex program includes the required instructions to perform skeletal animation.  <a href="#a3eaf8ab3e4b834a0ad24d70e210263cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a127f106471457c2987fa7fb9fbab4e99">Program</a> (<a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a127f106471457c2987fa7fb9fbab4e99"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a1738228b71726715dea9c34bed1933df">~Program</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#a1738228b71726715dea9c34bed1933df"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#adf0734235b627840d1349b2786ef10ce">destroyParameters</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy all parameters of this program.  <a href="#adf0734235b627840d1349b2786ef10ce"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a2a9a1ddf2b02f2e987ab2a1dcd87e157">destroyFunctions</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy all functions of this program.  <a href="#a2a9a1ddf2b02f2e987ab2a1dcd87e157"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#ad253b7046575be4da4ff605ff44611f1">addParameter</a> (<a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add parameter to this program.  <a href="#ad253b7046575be4da4ff605ff44611f1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a8435c04dbcf00c426772b6e1bd6dbd60">removeParameter</a> (<a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove parameter from this program.  <a href="#a8435c04dbcf00c426772b6e1bd6dbd60"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#abc8a386d882d0ee62ff4ae3b0593cf11">mType</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga76848ed6c023c3fe0a5e9f25f87b78a8">UniformParameterList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#aeae0ede3c6fdddacbd76f2fd4ded3442">mParameters</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a546b86929d98f266dff4e8200fb629c6">mFunctions</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#aea822dee4509c3bfc5ee8e2f69136645">mEntryPointFunction</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a04f22be521ef8873fdc6cfb7fc42aa1e">mDependencies</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a32c2651c973746f3cc2bfc3ad3d89b98">mSkeletalAnimation</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#ae46e120edae3a1f22dc68ebde7fbcfca">ProgramManager</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A class that represents a shader based program. </p>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00050">50</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a127f106471457c2987fa7fb9fbab4e99"></a><!-- doxytag: member="Ogre::RTShader::Program::Program" ref="a127f106471457c2987fa7fb9fbab4e99" args="(GpuProgramType type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a127f106471457c2987fa7fb9fbab4e99">Ogre::RTShader::Program::Program</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">type</td><td>The type of this program. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1738228b71726715dea9c34bed1933df"></a><!-- doxytag: member="Ogre::RTShader::Program::~Program" ref="a1738228b71726715dea9c34bed1933df" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Program.html#a1738228b71726715dea9c34bed1933df">Ogre::RTShader::Program::~Program</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a9eae71bfcd0da6a9daac3ddc52d27e25"></a><!-- doxytag: member="Ogre::RTShader::Program::addDependency" ref="a9eae71bfcd0da6a9daac3ddc52d27e25" args="(const String &amp;libFileName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a9eae71bfcd0da6a9daac3ddc52d27e25">Ogre::RTShader::Program::addDependency</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>libFileName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add dependency for this program. </p>
<p>Basically a filename that will be included in this program and provide predefined shader functions code. One should verify that the given library file he provides can be reached by the resource manager. This step can be achieved using the <a class="el" href="classOgre_1_1ResourceGroupManager.html#a63c9ac3c8701d58c8c8b8cf5f8df7849" title="Method to add a resource location to for a given resource group.">ResourceGroupManager::addResourceLocation</a> method. </p>

</div>
</div>
<a class="anchor" id="ad253b7046575be4da4ff605ff44611f1"></a><!-- doxytag: member="Ogre::RTShader::Program::addParameter" ref="ad253b7046575be4da4ff605ff44611f1" args="(UniformParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#ad253b7046575be4da4ff605ff44611f1">Ogre::RTShader::Program::addParameter</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add parameter to this program. </p>

</div>
</div>
<a class="anchor" id="aa3c0b7854fb8356b68ecb3b977c3f0fb"></a><!-- doxytag: member="Ogre::RTShader::Program::createFunction" ref="aa3c0b7854fb8356b68ecb3b977c3f0fb" args="(const String &amp;name, const String &amp;desc, const Function::FunctionType functionType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a>* <a class="el" href="classOgre_1_1RTShader_1_1Program.html#aa3c0b7854fb8356b68ecb3b977c3f0fb">Ogre::RTShader::Program::createFunction</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>desc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccf">Function::FunctionType</a>&#160;</td>
          <td class="paramname"><em>functionType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create new function in this program. </p>
<p>Return the newly created function instance. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the function to create. </td></tr>
    <tr><td class="paramname">desc</td><td>The description of the function. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2a9a1ddf2b02f2e987ab2a1dcd87e157"></a><!-- doxytag: member="Ogre::RTShader::Program::destroyFunctions" ref="a2a9a1ddf2b02f2e987ab2a1dcd87e157" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a2a9a1ddf2b02f2e987ab2a1dcd87e157">Ogre::RTShader::Program::destroyFunctions</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy all functions of this program. </p>

</div>
</div>
<a class="anchor" id="adf0734235b627840d1349b2786ef10ce"></a><!-- doxytag: member="Ogre::RTShader::Program::destroyParameters" ref="adf0734235b627840d1349b2786ef10ce" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#adf0734235b627840d1349b2786ef10ce">Ogre::RTShader::Program::destroyParameters</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy all parameters of this program. </p>

</div>
</div>
<a class="anchor" id="acdcfe31a4b135f4e86f22f7448d063c6"></a><!-- doxytag: member="Ogre::RTShader::Program::getDependency" ref="acdcfe31a4b135f4e86f22f7448d063c6" args="(unsigned int index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1Program.html#acdcfe31a4b135f4e86f22f7448d063c6">Ogre::RTShader::Program::getDependency</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the library name of the given index dependency. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>The index of the dependecy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af51a20c85418f770b3fdb56f82e03830"></a><!-- doxytag: member="Ogre::RTShader::Program::getDependencyCount" ref="af51a20c85418f770b3fdb56f82e03830" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1RTShader_1_1Program.html#af51a20c85418f770b3fdb56f82e03830">Ogre::RTShader::Program::getDependencyCount</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the number of external libs this program depends on. </p>

</div>
</div>
<a class="anchor" id="a7b7f2adb8e8b565d6ca1d1893af82b76"></a><!-- doxytag: member="Ogre::RTShader::Program::getEntryPointFunction" ref="a7b7f2adb8e8b565d6ca1d1893af82b76" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a>* <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a7b7f2adb8e8b565d6ca1d1893af82b76">Ogre::RTShader::Program::getEntryPointFunction</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the entry point function of this program. </p>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00147">147</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5ca247d24785aec3cdb24c5fec312c4b"></a><!-- doxytag: member="Ogre::RTShader::Program::getFunctionByName" ref="a5ca247d24785aec3cdb24c5fec312c4b" args="(const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a>* <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a5ca247d24785aec3cdb24c5fec312c4b">Ogre::RTShader::Program::getFunctionByName</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a function by a given name. </p>
<p>Return NULL if no matching function found. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the function to search for. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acf2a3a94886adfb88b0f85212f65c873"></a><!-- doxytag: member="Ogre::RTShader::Program::getFunctions" ref="acf2a3a94886adfb88b0f85212f65c873" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1Program.html#acf2a3a94886adfb88b0f85212f65c873">Ogre::RTShader::Program::getFunctions</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the function list of this program. </p>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00139">139</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="af817232435e35d8e747eed629e8a7caa"></a><!-- doxytag: member="Ogre::RTShader::Program::getParameterByAutoType" ref="af817232435e35d8e747eed629e8a7caa" args="(GpuProgramParameters::AutoConstantType autoType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#af817232435e35d8e747eed629e8a7caa">Ogre::RTShader::Program::getParameterByAutoType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a>&#160;</td>
          <td class="paramname"><em>autoType</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get parameter by a given auto constant type. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">autoType</td><td>The auto type of the parameter to search for. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Return NULL if no matching parameter found. </dd></dl>

</div>
</div>
<a class="anchor" id="ac9b3ac41bdbeb34c21b9ee428b75b859"></a><!-- doxytag: member="Ogre::RTShader::Program::getParameterByName" ref="ac9b3ac41bdbeb34c21b9ee428b75b859" args="(const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#ac9b3ac41bdbeb34c21b9ee428b75b859">Ogre::RTShader::Program::getParameterByName</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get parameter by a given name. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the parameter to search for. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Return NULL if no matching parameter found. </dd></dl>

</div>
</div>
<a class="anchor" id="ad6e5c14d3511acebe76cccb40d260c96"></a><!-- doxytag: member="Ogre::RTShader::Program::getParameterByType" ref="ad6e5c14d3511acebe76cccb40d260c96" args="(GpuConstantType type, int index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#ad6e5c14d3511acebe76cccb40d260c96">Ogre::RTShader::Program::getParameterByType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get parameter by a given type and index. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">type</td><td>The type of the parameter to search for. </td></tr>
    <tr><td class="paramname">index</td><td>The index of the parameter to search for. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Return NULL if no matching parameter found. </dd></dl>

</div>
</div>
<a class="anchor" id="a2479cc279c86c8e782b81889862f8a7b"></a><!-- doxytag: member="Ogre::RTShader::Program::getParameters" ref="a2479cc279c86c8e782b81889862f8a7b" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__RTShader.html#ga76848ed6c023c3fe0a5e9f25f87b78a8">UniformParameterList</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a2479cc279c86c8e782b81889862f8a7b">Ogre::RTShader::Program::getParameters</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the list of uniform parameters of this program. </p>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00124">124</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3eaf8ab3e4b834a0ad24d70e210263cb"></a><!-- doxytag: member="Ogre::RTShader::Program::getSkeletalAnimationIncluded" ref="a3eaf8ab3e4b834a0ad24d70e210263cb" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a3eaf8ab3e4b834a0ad24d70e210263cb">Ogre::RTShader::Program::getSkeletalAnimationIncluded</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether a vertex program includes the required instructions to perform skeletal animation. </p>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00173">173</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="a91593fdaa3588c534a5d567fb5c4433a"></a><!-- doxytag: member="Ogre::RTShader::Program::getType" ref="a91593fdaa3588c534a5d567fb5c4433a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a91593fdaa3588c534a5d567fb5c4433a">Ogre::RTShader::Program::getType</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the type of this program. </p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::Program::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::Program::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::Program::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::Program::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::Program::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::Program::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::Program::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::Program::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::Program::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::Program::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8435c04dbcf00c426772b6e1bd6dbd60"></a><!-- doxytag: member="Ogre::RTShader::Program::removeParameter" ref="a8435c04dbcf00c426772b6e1bd6dbd60" args="(UniformParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a8435c04dbcf00c426772b6e1bd6dbd60">Ogre::RTShader::Program::removeParameter</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove parameter from this program. </p>

</div>
</div>
<a class="anchor" id="a14f456c00a198c026043492b74f5c695"></a><!-- doxytag: member="Ogre::RTShader::Program::resolveAutoParameterInt" ref="a14f456c00a198c026043492b74f5c695" args="(GpuProgramParameters::AutoConstantType autoType, size_t data, size_t size=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a14f456c00a198c026043492b74f5c695">Ogre::RTShader::Program::resolveAutoParameterInt</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a>&#160;</td>
          <td class="paramname"><em>autoType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve uniform auto constant parameter with associated int data of this program. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">autoType</td><td>The auto type of the desired parameter. </td></tr>
    <tr><td class="paramname">data</td><td>The data to associate with the auto parameter. </td></tr>
    <tr><td class="paramname">size</td><td>number of elements in the parameter. Return parameter instance in case of that resolve operation succeeded. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af9ae3761783a43cdb7016b51c5a858bd"></a><!-- doxytag: member="Ogre::RTShader::Program::resolveAutoParameterInt" ref="af9ae3761783a43cdb7016b51c5a858bd" args="(GpuProgramParameters::AutoConstantType autoType, GpuConstantType type, size_t data, size_t size=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a14f456c00a198c026043492b74f5c695">Ogre::RTShader::Program::resolveAutoParameterInt</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a>&#160;</td>
          <td class="paramname"><em>autoType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve uniform auto constant parameter with associated int data of this program. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">autoType</td><td>The auto type of the desired parameter. </td></tr>
    <tr><td class="paramname">type</td><td>The desired data type of the auto parameter. </td></tr>
    <tr><td class="paramname">data</td><td>The data to associate with the auto parameter. </td></tr>
    <tr><td class="paramname">size</td><td>number of elements in the parameter. Return parameter instance in case of that resolve operation succeeded. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae0b281147a7daf59ec04e45523df75d0"></a><!-- doxytag: member="Ogre::RTShader::Program::resolveAutoParameterReal" ref="ae0b281147a7daf59ec04e45523df75d0" args="(GpuProgramParameters::AutoConstantType autoType, Real data, size_t size=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#ae0b281147a7daf59ec04e45523df75d0">Ogre::RTShader::Program::resolveAutoParameterReal</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a>&#160;</td>
          <td class="paramname"><em>autoType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve uniform auto constant parameter with associated real data of this program. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">autoType</td><td>The auto type of the desired parameter. </td></tr>
    <tr><td class="paramname">data</td><td>The data to associate with the auto parameter. </td></tr>
    <tr><td class="paramname">size</td><td>number of elements in the parameter. Return parameter instance in case of that resolve operation succeeded. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afa95a589bbc662fdadf93c9fa3630508"></a><!-- doxytag: member="Ogre::RTShader::Program::resolveAutoParameterReal" ref="afa95a589bbc662fdadf93c9fa3630508" args="(GpuProgramParameters::AutoConstantType autoType, GpuConstantType type, Real data, size_t size=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#ae0b281147a7daf59ec04e45523df75d0">Ogre::RTShader::Program::resolveAutoParameterReal</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3">GpuProgramParameters::AutoConstantType</a>&#160;</td>
          <td class="paramname"><em>autoType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve uniform auto constant parameter with associated real data of this program. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">autoType</td><td>The auto type of the desired parameter. </td></tr>
    <tr><td class="paramname">type</td><td>The desired data type of the auto parameter. </td></tr>
    <tr><td class="paramname">data</td><td>The data to associate with the auto parameter. </td></tr>
    <tr><td class="paramname">size</td><td>number of elements in the parameter. Return parameter instance in case of that resolve operation succeeded. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5587bc7123d7616527a4508706d7cc89"></a><!-- doxytag: member="Ogre::RTShader::Program::resolveParameter" ref="a5587bc7123d7616527a4508706d7cc89" args="(GpuConstantType type, int index, uint16 variability, const String &amp;suggestedName, size_t size=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a5587bc7123d7616527a4508706d7cc89">Ogre::RTShader::Program::resolveParameter</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>variability</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>suggestedName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve uniform parameter of this program. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">type</td><td>The type of the desired parameter. </td></tr>
    <tr><td class="paramname">index</td><td>The index of the desired parameter. </td></tr>
    <tr><td class="paramname">suggestedName</td><td>The suggested name for the parameter in case new one should be create. </td></tr>
    <tr><td class="paramname">variability</td><td>How this parameter varies (bitwise combination of GpuProgramVariability). </td></tr>
    <tr><td class="paramname">size</td><td>number of elements in the parameter. Return parameter instance in case of that resolve operation succeeded. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd><a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a> -1 as index parameter to create a new parameter with the desired type and index. </dd></dl>

</div>
</div>
<a class="anchor" id="a1d51026c1bafcac0223edb1e371c5b52"></a><!-- doxytag: member="Ogre::RTShader::Program::setEntryPointFunction" ref="a1d51026c1bafcac0223edb1e371c5b52" args="(Function *function)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a1d51026c1bafcac0223edb1e371c5b52">Ogre::RTShader::Program::setEntryPointFunction</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the entry point function. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">function</td><td>The function that will use as entry point of this program. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00144">144</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="a24f1c39c59041fb580260cd1a778c9eb"></a><!-- doxytag: member="Ogre::RTShader::Program::setSkeletalAnimationIncluded" ref="a24f1c39c59041fb580260cd1a778c9eb" args="(bool value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a24f1c39c59041fb580260cd1a778c9eb">Ogre::RTShader::Program::setSkeletalAnimationIncluded</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether a vertex program includes the required instructions to perform skeletal animation. </p>

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00168">168</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="ae46e120edae3a1f22dc68ebde7fbcfca"></a><!-- doxytag: member="Ogre::RTShader::Program::ProgramManager" ref="ae46e120edae3a1f22dc68ebde7fbcfca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00208">208</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a04f22be521ef8873fdc6cfb7fc42aa1e"></a><!-- doxytag: member="Ogre::RTShader::Program::mDependencies" ref="a04f22be521ef8873fdc6cfb7fc42aa1e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a04f22be521ef8873fdc6cfb7fc42aa1e">Ogre::RTShader::Program::mDependencies</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00205">205</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="aea822dee4509c3bfc5ee8e2f69136645"></a><!-- doxytag: member="Ogre::RTShader::Program::mEntryPointFunction" ref="aea822dee4509c3bfc5ee8e2f69136645" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a>* <a class="el" href="classOgre_1_1RTShader_1_1Program.html#aea822dee4509c3bfc5ee8e2f69136645">Ogre::RTShader::Program::mEntryPointFunction</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00204">204</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="a546b86929d98f266dff4e8200fb629c6"></a><!-- doxytag: member="Ogre::RTShader::Program::mFunctions" ref="a546b86929d98f266dff4e8200fb629c6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a546b86929d98f266dff4e8200fb629c6">Ogre::RTShader::Program::mFunctions</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00203">203</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="aeae0ede3c6fdddacbd76f2fd4ded3442"></a><!-- doxytag: member="Ogre::RTShader::Program::mParameters" ref="aeae0ede3c6fdddacbd76f2fd4ded3442" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga76848ed6c023c3fe0a5e9f25f87b78a8">UniformParameterList</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#aeae0ede3c6fdddacbd76f2fd4ded3442">Ogre::RTShader::Program::mParameters</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00202">202</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="a32c2651c973746f3cc2bfc3ad3d89b98"></a><!-- doxytag: member="Ogre::RTShader::Program::mSkeletalAnimation" ref="a32c2651c973746f3cc2bfc3ad3d89b98" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1Program.html#a32c2651c973746f3cc2bfc3ad3d89b98">Ogre::RTShader::Program::mSkeletalAnimation</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00206">206</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<a class="anchor" id="abc8a386d882d0ee62ff4ae3b0593cf11"></a><!-- doxytag: member="Ogre::RTShader::Program::mType" ref="abc8a386d882d0ee62ff4ae3b0593cf11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> <a class="el" href="classOgre_1_1RTShader_1_1Program.html#abc8a386d882d0ee62ff4ae3b0593cf11">Ogre::RTShader::Program::mType</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgram_8h_source.html#l00201">201</a> of file <a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderProgram_8h_source.html">OgreShaderProgram.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:33
</p>
</body>
</html>
